/*
 * Copyright 2000-2017 JetBrains s.r.o.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.intellij.openapi.vcs.ui;

import com.intellij.ide.ui.customization.CustomizableActionGroupProvider;
import com.intellij.openapi.actionSystem.ActionPlaces;
import com.intellij.openapi.vcs.VcsActions;

/**
 * @author gregsh
 */
public class VcsCustomizableActionGroupProvider extends CustomizableActionGroupProvider {
  @Override
  public void registerGroups(CustomizableActionGroupRegistrar registrar) {
    registrar.addCustomizableActionGroup(VcsActions.VCS_OPERATIONS_POPUP, "VCS Operations Popup");
    registrar.addCustomizableActionGroup(ActionPlaces.CHANGES_VIEW_TOOLBAR, "VCS Local Changes Toolbar");
    registrar.addCustomizableActionGroup(VcsActions.VCS_LOG_CHANGES_BROWSER_TOOLBAR, "VCS Log Changes Browser Toolbar");
  }
}
